/var/turn=1;
/var/mob/tcarrier;
/var/mob/tguardian;

/proc/Get_Dir(dir)
{
	switch (dir)
	{
		if (1) return "north";
		if (2) return "south";
		if (4) return "east";
		if (8) return "west";
	}
}


/proc/DoTurn()
{
	if (ended)
		return;

	players << "<B>Turn [turn]:</B>";

	for (var/mob/player/P in players)
	{
		if (P.loc == null)
			continue;

		P.pturn++;

		if (P.move != null && P.move != P.loc)
		{
			if (P.flee)
			{
				if (rand(1, 4) < P.flee + 3)
				{
					spawn(1) P.flee = 0;
					P << "You run for your life!";
					P.loc.contents - P << "\The [P] flees in terror [Get_Dir(get_dir(P.loc, P.move))]ward!";
					if (P.combat)
					{
						if (P.opponent && P.opponent.opponent) P.opponent.opponent = null;
						if (P.opponent) P.opponent.combat = null;
						P.opponent.adds = 0;
						P.adds = 0;
						P.opponent = null;
						del(P.combat);
						P.combat = null;
						P.loc:combat = null;
					}
				}
				else
				{
					P.flee = 0;
					P << "You try and escape your attacker but fail!";
					P.loc.contents - P << "\The [P] struggles to flee, but fails!";
					P.move = null;
					continue;
				}
			}

			if (P.move.contents.len == 0 && P.move)
			{
				var/randchance;

				randchance = max(34 - players.len - round(turn / 65, 1) + (P.z - 2) * 2, 10);

				if ((rand(1,randchance) == 1) || (rand(1,9) == 1 && P == tcarrier))
				{
					var/ttt[];

					switch (P.z)
					{
						if (1)
						{
							if (rand(1, 10) < 9)
								ttt = typesof(/mob/monster/common);
							else
								ttt = typesof(/mob/monster/unusual);
						}
						if (2)
						{
							if (rand(1, 10) < 9)
								ttt = typesof(/mob/monster/unusual);
							else
								ttt = typesof(/mob/monster/rare);
						}
						if (3)
						{
							if (rand(1, 10) < 10)
								ttt = typesof(/mob/monster/rare);
							else
								ttt = typesof(/mob/monster/legendary);
						}
						if (4)
						{
							if (rand(1, 10) < 4)
								ttt = typesof(/mob/monster/legendary);
							else
								ttt = typesof(/mob/monster/rare);
						}
					}

					ttt.Remove(/mob/monster, /mob/monster/common, /mob/monster/unusual, /mob/monster/rare, /mob/monster/legendary);

					var/t;

					for (var/i=1, i<=ttt.len, i++)
					{
						if (rand(1, (ttt.len + 1 - i)) == 1)
						{
							t = ttt[i];
							new t(P.move);
							P.loc << "You hear the angry growling of a wandering monster!";
							break;
						}
					}
				}
				else if (rand(1,randchance - 1) == 1)
				{
					var/ttt[];

					switch (P.z)
					{
						if (1)
						{
							if (rand(1, 10) < 7)
								ttt = typesof(/mob/companion/common);
							else
								ttt = typesof(/mob/companion/unusual);
						}
						if (2)
						{
							if (rand(1, 10) < 8)
								ttt = typesof(/mob/companion/unusual);
							else
								ttt = typesof(/mob/companion/rare);
						}
						if (3)
						{
							if (rand(1, 10) < 9)
								ttt = typesof(/mob/companion/rare);
							else
								ttt = typesof(/mob/companion/legendary);
						}
						if (4)
						{
							if (rand(1, 10) < 4)
								ttt = typesof(/mob/companion/legendary);
							else
								ttt = typesof(/mob/companion/rare);
						}
					}

					ttt.Remove(/mob/companion, /mob/companion/common, /mob/companion/unusual, /mob/companion/rare, /mob/companion/legendary);

					var/t;

					for (var/i=1, i<=ttt.len, i++)
					{
						if (rand(1, (ttt.len + 1 - i)) == 1)
						{
							t = ttt[i];
							new t(P.move);
							P.loc << "You hear footsteps nearby.";
							break;
						}
					}
				}
				else if (rand(1,randchance - 4) == 1)
				{
					var/ttt[];

					switch (P.z)
					{
						if (1)
						{
							if (rand(1, 10) < 7)
								ttt = typesof(/obj/item/common);
							else
								ttt = typesof(/obj/item/unusual);
						}
						if (2)
						{
							if (rand(1, 10) < 8)
								ttt = typesof(/obj/item/unusual);
							else
								ttt = typesof(/obj/item/rare);
						}
						if (3)
						{
							if (rand(1, 10) < 9)
								ttt = typesof(/obj/item/rare);
							else
								ttt = typesof(/obj/item/legendary);
						}
						if (4)
						{
							if (rand(1, 10) < 4)
								ttt = typesof(/obj/item/legendary);
							else
								ttt = typesof(/obj/item/rare);
						}
					}

					ttt.Remove(/obj/item, /obj/item/common, /obj/item/unusual, /obj/item/rare, /obj/item/legendary);

					var/t;

					for (var/i=1, i<=ttt.len, i++)
					{
						if (rand(1, (ttt.len + 1 - i)) == 1)
						{
							t = ttt[i];
							new t(P.move);
							P.loc << "Hidden in a pile of debris, you find an undiscovered treasure!";
							break;
						}
					}
				}
			}

			if (P.flee == 0)
				P.loc.contents - P << "[P.name] leaves [Get_Dir(get_dir(P.loc, P.move))].";


			var/turf/oldloc = P.loc;

			P.Move(P.move, get_dir(P.loc, P.move))
			P.loc.contents - P << "[P.name] enters from the [Get_Dir(turn(get_dir(oldloc, P.move), 180))].";

			oldloc.RevealAll();

			if (P.move.trap != null && rand(1, 10) <= 8)
			{
				var/safe = 0;

				for (var/obj/item/I in P.misc_equipped)
				{
					if (I.type == /obj/item/rare/ring_of_warning && rand(1, 5) >= 3)
					{
						safe = 1;
						break;
					}
				}

				if (P.class == "Engineer")
					safe = 1;

				if (safe == 0)
					P.move.trap.Triggered(P);
				else if (P.class == "Engineer")
					P << "Your keen eyes spot a hidden trap trigger, and you carefully step around it.";
				else
					P << "Your Ring of Warning lights up brilliantly, and you spot a trap trigger just in time to avoid it!";
			}

			P.move.Reveal(P);
			P.move.RevealAll();

			spawn(1) P.move = null;

			if (P.density == 0 && P.class != "Ghost")
				P.density = 1;
		}

		for (var/obj/item/C in P)
		{
			if (C.constant_use == 1 && C.equipped)
			{
				C.Magic_Use(P);
			}
		}
	}

	for (var/combat/C in combats)
	{
		C.RunCombatRound();
	}

	spawn(2)
	{
		for (var/mob/P in players)
		{
			P.adds = 0;
			P.def_adds = 0;
			P.lore_adds = 0;
			P.flee = 0;

			for (var/I in P.frames)
			{
				del (P.frames[I]);
			}

			for (var/mob/Q in players)
			{
				P.frames["[Q]"] = image('pframe.dmi', Q, colorlist[Q.color]);
				P << P.frames["[Q]"];
			}

			if (P:carrier)
				del (P:carrier);

			var/atom/find = locate(/obj/item/treasure_hoard);
			find = find.loc;
			if (isturf(find))
			{
				P:carrier = image('tcarrier.dmi', find, layer=10);
				P << P:carrier;
			}
			if (istype(find, /mob/player))
			{
				P:carrier = image('tcarrier.dmi', find, layer=10);
				P << P:carrier;
				tcarrier = find;
			}
			else
				tcarrier = null;

			if (P.weapon && P.weapon.item_type == "bow" && !(P.opponent))
				P.weapon.loaded = 1;

			if (P.companions.len > P.charisma)
			{
				P << "Your leadership over the party is faltering!";
				while (P.companions.len > P.charisma)
				{
					for (var/i=1, i<=P.companions.len, i++)
					{
						if (rand(1, P.companions.len + 1 - i) == 1 && (P.type != /mob/companion/legendary/devil))
						{
							usr = P;
							var/mob/companion/C = P.companions[i];
							C.Dismissal();
							break;
						}
					}
				}
			}

			for (var/mob/companion/C in P.companions)
			{
				if (C.type == /mob/companion/rare/thief && (!P.client || P.client.statpanel != "Inventory"))
				{
					for (var/obj/item/I in P.contents)
					{
						if (I.worth <= 50 && rand(1,25) == 1)
						{
							P.score -= I.worth;
							del(I);
						}

						if (rand(1, 10) == 2)
						{
							spawn(1)
							{
								if (P)
								{
									P.companions.Remove(C);
									del(C);
								}
							}
						}
					}
				}
			}

			for (var/mob/M in P.loc)
			{
				if (M == P) continue;

				if (istype(M, /mob/monster) && M.opponent == null)
				{
					var/targlist[] = list();
					for (var/mob/T in P.loc)
					{
						if (M.type == /mob/monster/guardian)
						{
							if (istype(T, /mob/player) && T.opponent == null)
							{
								targlist.Add(T);
								continue;
							}
						}

						var/save = 1;
						if ((T.class != "Priest" || M.undead != 1) && (T.class != "Ninja" || rand(1,16) == 1) && (T.class != "Thug" || T.attack <= M.attack || istype(M, /mob/monster/rare) || rand(1,8) == 7))
							save = 0;

						for (var/obj/item/C in T.misc_equipped)
						{
							if (C.type == /obj/item/rare/ring_of_invisibility && save != -1)
								save = 1;

							if (C.type == /obj/item/treasure_hoard)
								save = -1;
						}

						if ((save < 1 || istype(M, /mob/monster/legendary)) && (istype(T, /mob/player) && T.opponent == null))
							targlist.Add(T);
					}

					if (targlist.len > 0)
					{
						for (var/i=1, i<=targlist.len, i++)
						{
							if (rand(1, targlist.len + 1 - i) == 1)
								M.opponent = targlist[i];
						}
					}
					else
					{
						for (var/mob/T in P.loc)
						{
							if (istype(T, /mob/player))
							{
								if (T.class == "Priest" && M.undead == 1)
								{
									P.loc.contents << "\The [M] shrieks as it attempts to attack [T] but is driven back by an unseen force.";
									return;
								}
								else if (T.class == "Thug" && T.attack > M.attack)
								{
									P.loc.contents - T << "\The [M] starts to rush at [T] as if to attack, but [T]'s intimidating look quickly changes its mind.";
									T << "\The [M] starts to rush at you as if to attack, but it takes one look at you and quickly changes its mind.";
								}
							}
						}
					}

					if (M.opponent)
					{
						M:Attack(M.opponent);
					}
				}
			}
		}
	}

	turn++;

	spawn (120) DoTurn();
}