/var
{
	ban_list[][] = list(); //first list index is IP, second list index is associated keys
	mob/host;
}

/proc
{
	LoadBanList()
	{
		var/save = "banned.lst";

		if (length(file(save)))
		{
			var/savefile/F = new(save);

			F >> ban_list;
		}
	}

	SaveBanList()
	{
		var/save = "banned.lst";

		var/savefile/F = new(save);

		F << ban_list;
	}
}

/mob
{
	host
	{
		verb
		{
			boot(mob/player as mob in players)
			{
				set category = "Host";

				if (player == usr)
					return;

				del(player.client);
				for (var/obj/item/I in player.contents)
				{
					I.loc = player.loc;
				}
				players << "[player] has been booted.";
				players.Remove(player);
				del (player);
			}

			ban(mob/player as mob in players)
			{
				set category = "Host";

				if (player == usr)
					return;

				ban_list["[player.client.address]"] = list();
				var/blist[] = ban_list["[player.client.address]"];
				blist.Add(player.key);

				del(player.client);
				for (var/obj/item/I in player.contents)
				{
					I.loc = player.loc;
				}
				players << "[player] has been banned.";
				players.Remove(player);
				del (player);

				SaveBanList();
			}

			start()
			{
				set category = "Host";

				if (world.time > 320)
					spawn(180) DoTurn();

					usr.verbs -= /mob/host/verb/start;

					players << "<B>Game started!</B>";
			}

			mute(mob/player as mob in players)
			{
				set category = "Host";

				players << "[player] has been muted.";
				player.verbs.Remove(/mob/verb/say);
			}

/*
			unban_IP(IP in ban_list)
			{
				set category = "Host";

				ban_list["[IP] leftovers"] = ban_list["[IP]"];
				ban_list.Remove(ban_list["[IP]"]);
			}

			unban_key(key as text)
			{
				set category = "Host";

				for (var/i=1, i<=ban_list.len, i++)
				{
					if (key in ban_list[i])
					{
						var/b[] = ban_list[i];
						b.Remove(key);
					}
				}
			}

			show_bans()
			{
				set category = "Host";

				usr << "<B>Banned IPs:</B>";

				for (var/i=1, i<=ban_list.len, i++)
				{
					usr << ban_list[i];
				}

				usr << "<B>Banned keys:</B>";

				for (var/i=1, i<=ban_list.len, i++)
				{
					var/b[] = ban_list[ban_list[i]];

					for (var/j=1, j<=b.len, j++)
					{
						usr << b[j];
					}
				}
			}
*/

			unmute(mob/player as mob in players)
			{
				set category = "Host";

				player.verbs.Add(/mob/verb/say);
			}
		}
	}
}